<?php

add_action('admin_menu', 'pcontents_admin_menu');

function pcontents_admin_menu() {
    add_options_page('Premium Contents', 'Premium Contents', 'manage_options', 'premium-contents/options.php');
}

register_activation_hook('premium-contents/plugin.php', 'pcontents_activate');

function pcontents_activate() {

}

register_deactivation_hook('premium-contents/plugin.php', 'pcontents_deactivate');

function pcontents_deactivate() {

}

add_action('admin_init', 'pcontents_admin_init');

function pcontents_admin_init() {
    if (isset($_GET['page']) && strpos($_GET['page'], 'premium-contents/') === 0) {
        wp_enqueue_script('jquery-ui-tabs');
    }
}

add_action('admin_head', 'pcontents_admin_head');

function pcontents_admin_head() {
    if (isset($_GET['page']) && strpos($_GET['page'], 'premium-contents/') === 0) {
        echo '<link type="text/css" rel="stylesheet" href="' . WP_PLUGIN_URL . '/premium-contents/admin.css?' . PREMIUM_CONTENTS_VERSION . '"/>';
        //echo '<script src="' . LITE_CACHE_URL . '/admin.js?' . LITE_CACHE_VERSION . '"></script>';
    }
}
