<?php
require_once '../../../wp-load.php';
header('Content-Type: text/html;charset=UTF-8');
header('X-Robots-Tag: noindex,nofollow,noarchive');

$options = get_option('premium_contents');

if (!defined('FB_APP_ID') && isset($options['facebook_app_id'])) {
    define('FB_APP_ID', $options['facebook_app_id']);
}

if (!defined('FB_APP_SECRET') && isset($options['facebook_app_secret'])) {
    define('FB_APP_SECRET', $options['facebook_app_secret']);
}

session_start();

$code = $_REQUEST["code"];

$ctx = $_GET['ctx'];

if (empty($code)) {
    $url = plugins_url('premium-contents/facebook.php');
    if (isset($_GET['return'])) {
        $url .= '?return=' . urlencode($_GET['return']);
        unset($_GET['return']);
    } else {
        $url .= '?return=' . urlencode($_SERVER['HTTP_REFERER']);
    }

    if (!empty($_GET)) {
        foreach ($_GET as $name => $value) {
            $url .= '&' . $name . '=' . urlencode($value);
        }
    }
    
    $_SESSION['url'] = $url;
    
    /*
      if (!empty($_GET['error'])) {  //Does not have permission - send to fb asking for permission
      // TODO: Mandarli sulla pagina del ripensamento
      header('Location: explain.php?return=' . urlencode($_GET['return']));
      die();
      }
     */

    $_SESSION['state'] = md5(uniqid(rand(), true));

    switch ($ctx) {
        case 'popup':
            header("Location: https://www.facebook.com/dialog/oauth?client_id=" . FB_APP_ID . "&redirect_uri=" .
                    urlencode($url) . "&state=" . $_SESSION['state'] . "&display=popup&scope=email");
            break;
        default:
            header("Location: https://www.facebook.com/dialog/oauth?client_id=" . FB_APP_ID . "&redirect_uri=" .
                    urlencode($url) . "&state=" . $_SESSION['state'] . "&scope=email");
    }

    die();
} else {
    if (empty($_SESSION['state']) || ($_SESSION['state'] !== $_REQUEST['state'])) {
        die("No state, hack attempt?");
    }

    $token_url = "https://graph.facebook.com/oauth/access_token?"
            . "client_id=" . FB_APP_ID . "&redirect_uri=" . urlencode($_SESSION['url'])
            . "&client_secret=" . FB_APP_SECRET . "&code=" . $code;

    $response = @file_get_contents($token_url);
    $params = null;
    parse_str($response, $params);

    $fb_user = json_decode(@file_get_contents("https://graph.facebook.com/me?access_token=" . $params['access_token']));

    $wp_user_query = new WP_User_Query(array('meta_key' => 'facebook_id', 'meta_value' => $fb_user->id, 'number' => 1));
    $results = $wp_user_query->get_results();
    if (!empty($results)) {
        $user = $results[0];
        wp_set_auth_cookie($user->ID, true, is_ssl());
    } else {
        $user = array();

        if (empty($fb_user->username)) $fb_user->username = $fb_user->id;
        $user['user_login'] = $fb_user->username;
        $user['user_nicename'] = sanitize_title($fb_user->username);
        $user['user_url'] = '';
        $user['user_email'] = $fb_user->email;
        $user['display_name'] = $fb_user->first_name;
        $password = wp_generate_password();
        $user['user_pass'] = wp_hash_password($password);
        //$user['user_pass'] = wp_hash_password($password);
        $user['user_registered'] = gmdate('Y-m-d H:i:S');

        $wpdb->insert($wpdb->users, $user);
        $user_id = $wpdb->insert_id;
        
        file_put_contents('./test.txt', $user_id);

        update_user_meta($user_id, 'first_name', $fb_user->first_name);
        update_user_meta($user_id, 'last_name', $fb_user->last_name);
        update_user_meta($user_id, 'nickname', $fb_user->first_name);
        update_user_meta($user_id, 'description', '');
        update_user_meta($user_id, 'rich_editing', 'true');
        update_user_meta($user_id, 'comment_shortcuts', 'false');
        update_user_meta($user_id, 'admin_color', 'fresh');
        update_user_meta($user_id, 'use_ssl', 0);
        update_user_meta($user_id, 'facebook_id', $fb_user->id);
        update_user_meta($user_id, 'facebook_data', $fb_user);

        $user = new WP_User($user_id);
        $user->set_role(get_option('default_role'));
        
        do_action('user_register', $user_id);

        wp_set_auth_cookie($user_id, true, is_ssl());
    }
}
?><!DOCTYPE html>
<html>
    <head>
        <script>
            location.href = "<?= isset($_REQUEST['return']) ? $_REQUEST['return'] : '/' ?>";
        </script>
    </head>
</html>


