<?php

include '../../../wp-load.php';

if (!is_user_logged_in()) {
    header('Location: ' . wp_login_url(WP_PLUGIN_URL . '/premium-contents/ipn.php'));
    die();
}

$user_id = get_current_user_id();

if (!pcontents_is_expired()) {
    die('You already paid till ' . date('Y-m-d', get_user_meta($user_id, 'premium_contents_expire', true)));
}

$options = get_option('premium_contents');
if (empty($options['currency'])) $options['currency'] = 'USD';

$url = 'https://www.paypal.com/cgi-bin/webscr?cmd=_xclick' .
        '&custom=' . get_current_user_id() .
        '&item_number=1' .
        '&currency_code=' . $options['currency'] .
        '&amount=' . urlencode($options['price']) .
        '&business=' . $options['paypal_email'] .
        '&item_name=' . urlencode(get_option('blogname')) .
        '&notify_url=' . urlencode(WP_PLUGIN_URL . '/premium-contents/ipn.php') .
        '&return=' . urlencode(WP_PLUGIN_URL . '/premium-contents/thankyou.php');

error_log($url);

header('Location: ' . $url);
?>
